/*
 * PHOSPHOR_PROGRAMMER
 *
 * Created: March 2019
 * Author: Joris Wegner (joriswegner.de)
 * 
 * Use this sketch together with the supplied processing sketch to find glitchy patches you like.
 * See processing sketch for instructions.
 * 
 * USE THIS DEVICE AT YOUR OWN RISK. Using the original software to create and use patches as well as the recommended
 * parts, the unit should use much less current then a usb port can deliver. The video circuitry should be isolated 
 * well enough from the controller circuit that is connected to the computer. However, I am not responsible for any damage
 * that could occur while using this device.
 *
 */ 

#include "SparkFun_Tlc5940.h"
bool debug = true;

int value = 0;

int a = 0; int b = 0; int c = 0; int d = 0; int e = 0; int f = 0;
int g = 0; int h = 0; int i = 0; int j = 0; int k = 0;

int led = 14;

void setup() {
  Serial.begin(115200);
  Tlc.init();
  //while (!Serial);
  //Serial.begin(115200);

  digitalWrite(led, LOW);

 

  // I used an led on pin 4 to test this
  if (debug) {
    digitalWrite(led, HIGH);
    Serial.println("Pin 4 max");
    Tlc.set(4, 4000);
    Tlc.update();
    delay(6000);
    digitalWrite(led, LOW);
    Serial.println("Pin 4 off");
    Tlc.set(4, 0);
    Tlc.update();
  }
}

// Recieve a string of values
void loop() {


  if (Serial.available() > 0) {
    a = Serial.parseInt();
    b = Serial.parseInt();
    c = Serial.parseInt();
    d = Serial.parseInt();
    e = Serial.parseInt();
    f = Serial.parseInt();
    g = Serial.parseInt();
    h = Serial.parseInt();
    i = Serial.parseInt();
    j = Serial.parseInt();
    k = Serial.parseInt();
    Serial.read();
    setTlc();
  }
}

// Set the TLC to the transmitted value
void setTlc() {
  digitalWrite(led, HIGH);
  if (debug) Serial.println("setTlc");

  Tlc.set(4,  a);
  Tlc.set(1,  b);
  Tlc.set(5,  c);
  Tlc.set(2,  d);
  Tlc.set(9,  e);
  Tlc.set(11, f);
  Tlc.set(14, g);
  Tlc.set(3,  h);
  Tlc.set(13, i);
  Tlc.set(12, j);
  Tlc.set(10, k);

  if (debug) Serial.println("Update");
  Tlc.update();
  digitalWrite(led, LOW);
}
